//
// Centipede for Cybiko by ssjx (2015)
//

#include <cybiko.h>
#include "header.h"

void snapshot(char *);
int waitinput(struct module_t *);

void center(struct module_t *,char *,int );
//
//
//


struct module_t main_module;
struct DirectKeyboard *keys;

struct Input * ptr_input;
struct Bitmap bmp_brick,bmp_shot,bmp_player,bmp_mushroom,bmp_cent;

click_kind_t click_type;

struct{
	int x;
	int y;
	int inv;
	int lives;
	int score;
}player;

struct{
	int a;
	int x;
	int y;
	int xdir;
	int ydir;
	int head;
}cent[100];

struct{
	int a;
	int x;
	int y;
}shot[10];

//
//
//
int clen=0;
char map[LEVELWIDTH*LEVELHEIGHT];

//
// Map 
//

int add_mushrooms(int no)
{
	int i,pos;
	int mx=(LEVELWIDTH*LEVELHEIGHT)-(LEVELWIDTH*4);
	
	srand( clock() );
	
	for(i=0;i<no;i++)
	{
		pos=(LEVELWIDTH*2)+random(mx);
		map[pos]=1;
	}

}

int gridpos(int x,int y)
{
	int pos=(y*LEVELWIDTH)+x;
	
	if (pos<0){return 0;}
	
	return map[pos];
}

int grid_set(int x,int y,int v)
{
	int pos=(y*LEVELWIDTH)+x;
	map[pos]=v;
}

void drawlevel(struct module_t *ptr_main_module)
{
	int c=0;
	int i,j;
	for (j=0;j<96;j+=8)	//levelheight*8
	{
		for (i=0;i<160;i+=8)
		{
		if (map[c]>0){Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_mushroom, i,j, BM_NORMAL );}	
		c++;
		}
	}
}



//
//
//

void reset()
{
	int i=0;
	
	for(i=0;i<100;i++)
	{
		cent[i].a=-1;
	}

	clen=10;
	
	for(i=0;i<clen;i++)
	{
		cent[i].a=1;
		cent[i].x=-i;
		cent[i].y=1;
		cent[i].xdir=1;
		cent[i].ydir=1;
	}
	
	for(i=0;i<sizeof(map);i++)
	{
		map[i]=0;
	}

	add_mushrooms(20);


	player.x=10;
	player.y=10;
	player.inv=0;
	player.score=0;
	player.lives=3;
}

void next_level()
{
	int i;

	for(i=0;i<100;i++)
	{
		cent[i].a=-1;
	}

	clen+=2;
	
	for(i=0;i<clen;i++)
	{
		cent[i].a=1;
		cent[i].x=-i;
		cent[i].y=1;
		cent[i].xdir=1;
		cent[i].ydir=1;
	}
	add_mushrooms(5);
}

//
// Centipede
//

void cent_update()
{
int i,newx=0,newy=0;

for(i=0;i<clen;i++)//cent.length
{

	if (cent[i].y==1 && cent[i].x<0)
	{
		newx=0;
	}
	else
	{
		newx=cent[i].x+cent[i].xdir;
	}

	if (newx>(LEVELWIDTH-1) || newx<0)
	{
		cent[i].xdir*=-1;
	
		newy=cent[i].y+cent[i].ydir;
		
		if (newy<0 || newy>11)
		{
			cent[i].ydir*=-1;
		}
	
		if (cent[i].ydir==-1 && newx>LEVELWIDTH &&newy<=5)
		{
			cent[i].ydir*=-1;
		}
	
		cent[i].y+=cent[i].ydir;
		
		
	}
	else
	{
			if (gridpos(cent[i].x+cent[i].xdir,cent[i].y)==0)
			{
				cent[i].x+=cent[i].xdir;
			}
			else
			{
				cent[i].xdir*=-1;
			
				newy=cent[i].y+cent[i].ydir;
				if (newy<0 || newy>11)
				{
					cent[i].ydir*=-1;
				}
			
				if (cent[i].ydir==-1 && newy<=5)
				{
					cent[i].ydir*=-1;
				}
				
				cent[i].y+=cent[i].ydir;
			
			}
	}
	
}

}


int cent_check()
{
	int ln=0;
	int i;
		
	for(i=0;i<clen;i++)
	{
		if (cent[i].a==1)
		{
		ln++;
		}
	}
	return ln;
}

// Player hit/moved onto centipede?
int cent_hit()
{
	int i;
	
	if (player.inv>0){return 0;}
	
	for(i=0;i<clen;i++)//cent.length
	{
		if (cent[i].a==1)
		{
			if (cent[i].x==player.x && cent[i].y==player.y)
			{
			return 1;
			}
		}
	}
	
	return 0;
}

//
//
//

void shot_add(int x,int y)
{
	int i;

	for(i=0;i<10;i++)
	{
		if (shot[i].a==0)
		{
		shot[i].a=1;
		shot[i].x=x;
		shot[i].y=y;
		break;
		}
	}
}

void shot_update()
{
int c=0,i=0;
int gp=0;

	for(i=0;i<10;i++)
	{
		if (shot[i].a==1)
		{
			if (shot[i].y<0)
			{
				shot[i].a=0;
				//break;
			}
			else
			{
				// Hit centipede
				for(c=0;c<clen;c++)
				{
					if (cent[c].a==1)
					{
						if (cent[c].x==shot[i].x && cent[c].y==shot[i].y)
						{
							player.score+=10;
							shot[i].a=0;
							cent[c].a=0;
							grid_set(cent[c].x,cent[c].y,1);	// Add Mushroom
							
							//
							if (cent_check()==0)
							{
							next_level();
							}
							//cent_head();
						}
					}
				
				}
				
				if (shot[i].a==1)
				{
					// Hit mushroom
					gp=gridpos(shot[i].x,shot[i].y);
					if (gp>0)
					{
						grid_set(shot[i].x,shot[i].y,gp-1);	
						shot[i].a=0;
						
						// Removed mushroom!
						if (gridpos(shot[i].x,shot[i].y)==0)
						{
						player.score+=10;
						}
					}
				}
				
				// If shot is still active...
				if (shot[i].a==1)
				{
					shot[i].y--;
				}
			}
		}
	}
}




//
//
// 
     
long main(int argc, char *argv[],bool start)
{
int i,ext=0,level=0,width;
int alt=0,takeshot=0,firecount=0;
int hiscore=10;

int score_width;
char score_str[20],level_str[20];
char *dis; //,*map;

//map=(char *)malloc(250); 

TRACE("Centipede by ssjx");

init_module( &main_module );

Graphics_set_font( main_module.m_gfx, mini_normal_font );

dis=DisplayGraphics_get_page_ptr(main_module.m_gfx, 0);
keys = DirectKeyboard_get_instance();
//
// Load our graphics
//
	
	Bitmap_ctor(&bmp_cent);
	
	ptr_input = open_resource_Ex( "cent.pic" );
	if (!Bitmap_load( &bmp_cent, ptr_input ))
	{
	TRACE("Error loading centipede");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_player);
	
	ptr_input = open_resource_Ex( "player.pic" );
	if (!Bitmap_load( &bmp_player, ptr_input ))
	{
	TRACE("Error loading centipede");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_shot);
	
	ptr_input = open_resource_Ex( "shot.pic" );
	if (!Bitmap_load( &bmp_shot, ptr_input ))
	{
	TRACE("Error loading shot");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_mushroom);
	
	ptr_input = open_resource_Ex( "mushroom.pic" );
	if (!Bitmap_load( &bmp_mushroom, ptr_input ))
	{
	TRACE("Error loading mushroom");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
		
//
// Turn off keyboard beeping...
//	

click_type = get_click_kind(); // So we can restore it when we exit

set_click_kind( CK_NO );

//
// Title Screen
//
do
{

	TGraph_set_color( main_module.m_gfx, CLR_BLACK );
	
	memset(dis,0,4000); // Clear screen
	
	DisplayGraphics_draw_text( main_module.m_gfx, "Centipede", 1, 1 );
	
	DisplayGraphics_draw_text( main_module.m_gfx, "by ssjx", 1, 10 );
	
	DisplayGraphics_draw_text( main_module.m_gfx, "High Score", 1, 25 );
	sprintf(score_str,"%d",hiscore);
	DisplayGraphics_draw_text( main_module.m_gfx, score_str, 1, 35 );
	
	DisplayGraphics_draw_text( main_module.m_gfx, "Previous Score", 1, 45 );
	sprintf(score_str,"%d",player.score);
	DisplayGraphics_draw_text( main_module.m_gfx, score_str, 1, 55 );
	
	DisplayGraphics_draw_text( main_module.m_gfx, "Space = Start", 1, 80 );
	
	//footer
	TGraph_draw_line( main_module.m_gfx, 0, 89, 160, 89 );
	
	DisplayGraphics_draw_text( main_module.m_gfx, "http://ssjx.co.uk", 1, 90 );
	DisplayGraphics_draw_text( main_module.m_gfx, "v0.1", 140, 90 );
	
	DisplayGraphics_show(main_module.m_gfx );

	ext=0;
	if (waitinput(&main_module)==KEY_ESC)
	{
		TRACE("Escape from the title screen...");
		ext=2;
	}
	
	if (ext==0)
	{
	
	reset();
		do
		{
		
			ext=0;
			
			// Get Player Input
			DirectKeyboard_scan( keys );
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_X ) )
			{
				TRACE("Escape!");
				ext=1;
			}
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) )
			{
				if (gridpos(player.x,player.y-1)==0)
				{
				if (player.y!=0){player.y--;}
				}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) )
			{
				if (gridpos(player.x,player.y+1)==0)
				{
				if (player.y!=11){player.y++;}
				}	
			}
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
			{
				if (gridpos(player.x-1,player.y)==0)
				{
				if (player.x!=0){player.x--;}
				}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
			{
				if (gridpos(player.x+1,player.y)==0)
				{
				if (player.x!=19){player.x++;}	
				}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_SPACE ) || DirectKeyboard_is_key_pressed( keys, KEY_ENTER ))
			{
				if (firecount==0)
				{
					shot_add(player.x,player.y);
					firecount=3;
				}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_H )  )
			{
				takeshot=1;
			}
	
	
		//
		// DRAW THE LEVEL
		//
		memset(dis,0,4000); // Clear screen
		
		// Draw player shot
		for(i=0;i<10;i++)
		{
			if (shot[i].a==1)
			{
				Graphics_draw_bitmap(main_module.m_gfx, &bmp_shot, (shot[i].x<<3), (shot[i].y<<3), BM_NORMAL );
			}
		}
		
		drawlevel(&main_module.m_gfx);
		
		// Draw Centipede
		for(i=0;i<clen;i++)
		{
			if (cent[i].a==1 && cent[i].x>=0)
			{
			Graphics_draw_bitmap(main_module.m_gfx, &bmp_cent, (cent[i].x<<3), (cent[i].y<<3), BM_NORMAL );
			}
			
			if (cent[i].a==-1){break;}
		}
		
		
		
		//draw player
		if (player.inv>0)
		{
			player.inv--;
			
			if (alt==1)
			{
				Graphics_draw_bitmap(main_module.m_gfx, &bmp_player, player.x<<3, (player.y<<3), BM_NORMAL );
			}
		}
		else
		{
			Graphics_draw_bitmap(main_module.m_gfx, &bmp_player, player.x<<3, (player.y<<3), BM_NORMAL );
		}
		
		// Draw status
		sprintf(score_str,"%d",player.score);
		width=Font_string_width( DisplayGraphics_get_font( main_module.m_gfx),score_str );
		
		DisplayGraphics_draw_text( main_module.m_gfx, score_str, 160-width, 0 );
		
		for(i=0;i<player.lives;i++)
		{
		Graphics_draw_bitmap(main_module.m_gfx, &bmp_player, (i<<3), 0, BM_NORMAL );
		}
		
		DisplayGraphics_show(main_module.m_gfx );
		
		
		
		shot_update();
		
		if (alt==1)
		{
			cent_update();
		}
		
		if (cent_hit()==1 && player.inv==0)
		{
			player.lives--;
			
			if (player.lives<0)
			{
			ext=1;
			}
			else
			{
			player.inv=5;
			}
		
		}
		
		
		// take a snapshot after we have drawn everything
		if (takeshot==1)
		{
			snapshot(dis);
			takeshot=0;
		}
		
		//
		sleep(10);
		alt=1-alt;
		
		if (firecount>0){firecount--;}
		
		//
		}while(ext==0);

		switch(ext)
		{
			case 1:
				//Player lost all lives...
				center(&main_module,"Gameover!",45);
				DisplayGraphics_show(main_module.m_gfx );
				waitinput(&main_module);
				
				if (player.score>hiscore){hiscore=player.score;}
			break;
		}
	}

}while(ext!=2);

//	center(&main_module,"Thanks for playing!",45);
//	DisplayGraphics_show(main_module.m_gfx );
//	waitinput(&main_module);

TRACE("Finished");

set_click_kind( click_type );

DirectKeyboard_dtor( keys, FREE_MEMORY );
Bitmap_dtor( &bmp_brick, LEAVE_MEMORY );
Bitmap_dtor( &bmp_player, LEAVE_MEMORY );
Bitmap_dtor( &bmp_shot, LEAVE_MEMORY );
Bitmap_dtor( &bmp_cent, LEAVE_MEMORY );
Bitmap_dtor( &bmp_mushroom, LEAVE_MEMORY );

return 0L;
}
